/*
Ruan Rothmann
Class wat gebruik word vir die laai van Images.
*/

import java.awt.*;
import java.awt.image.*;
import java.net.URL;
import javax.imageio.*;
public class ImageUtil
{
    GraphicsConfiguration gc;
    Game game;
    BufferedImage backgroundArray[] [] = new BufferedImage [2] [3];
    BufferedImage powerupArray[] = new BufferedImage [7];
    BufferedImage explosions[] = new BufferedImage [Explosion.frames * 2];
    public static final int BACKGROUND = 0;
    public ImageUtil (GraphicsConfiguration g, Game owner)
    {
	gc = g;
	game = owner;
	for (int x = 0 ; x < 3 ; x++)
	    backgroundArray [0] [x] = loadImage ("backg" + (x + 1));
	for (int x = 0 ; x < 3 ; x++)
	    backgroundArray [1] [x] = loadImage ("tagbackg" + (x + 1));
	for (int x = 0 ; x < Explosion.frames ; x++)
	    explosions [x] = loadImage ("explosion" + (x + 1));

	for (int x = 0 ; x < Explosion.frames ; x++)
	    explosions [Explosion.frames + x] = loadImage ("spark" + (x + 1));

	powerupArray [0] = loadImage ("boot");
	powerupArray [1] = loadImage ("forcegun");
	powerupArray [2] = loadImage ("invisibility");
	powerupArray [3] = loadImage ("teleport");
	powerupArray [4] = loadImage ("gun");
	powerupArray [5] = loadImage ("mine");
	powerupArray [6] = loadImage ("shock");
    }


    private BufferedImage loadImage (String name)
    {
	//System.out.println (name);
	BufferedImage source;
	try
	{
	    URL url = this.getClass().getResource ("images/" + name + ".gif");
	    //URL url = this.getClass().getResource ("ImageUtil.class");
	   // System.out.println(url);
	    source = ImageIO.read (url);

	    // MediaTracker mt = new MediaTracker (game.mainFrame);
	    //mt.addImage (source, 0);
	    // try
	    // {
	    //     mt.waitForAll ();
	    // }
	    // catch (Exception e)
	    // {
	    // }
	    BufferedImage dst = gc.createCompatibleImage (source.getWidth (null), source.getHeight (null), Transparency.BITMASK);
	    //createCompatibleImage maak 'n image wat op VRAM gestoor word. cpu hoef dit dan nie te teken nie.
	    Graphics2D g = dst.createGraphics ();

	    g.drawImage (source, 0, 0, null);
	    g.dispose ();

	    return dst;
	}
	catch (Exception e)
	{
	    e.printStackTrace ();
	    //System.exit (1);
	}
	return null;

    }


    public BufferedImage getBackImage (boolean tag, int num)
    {
	if (tag)
	    return backgroundArray [1] [num];
	else
	    return backgroundArray [0] [num];
    }


    public BufferedImage[] getWarriorImages (String col)
    {
	//eerste 14 Images is links, tweede is regs dan twee climbing.
	String imageToGet;
	String facing = "l";
	BufferedImage[] arr = new BufferedImage [30];

	arr [0] = loadImage (col + "stand" + facing);
	arr [1] = loadImage (col + "walk" + facing + "1");
	arr [2] = loadImage (col + "walk" + facing + "2");
	arr [3] = loadImage (col + "walk" + facing + "3");
	arr [4] = loadImage (col + "jump" + facing + "1");
	arr [5] = loadImage (col + "jump" + facing + "2"); //dit kon seker beter gedoen geword het.
	arr [6] = loadImage (col + "fall" + facing + "1"); //maar dit mag onnodige bugs veroorsaak het, dit
	arr [7] = loadImage (col + "fall" + facing + "2"); //word min genoeg gerun om hierdie bietjie tikwerk
	arr [8] = loadImage (col + "crouch" + facing); //te veroorsaak
	arr [9] = loadImage (col + "roll" + facing + "1");
	arr [10] = loadImage (col + "roll" + facing + "2");
	arr [11] = loadImage (col + "roll" + facing + "3");
	arr [12] = loadImage (col + "crouchs" + facing);
	arr [13] = loadImage (col + "shoot" + facing);

	facing = "r";

	arr [14] = loadImage (col + "stand" + facing);
	arr [15] = loadImage (col + "walk" + facing + "1");
	arr [16] = loadImage (col + "walk" + facing + "2");
	arr [17] = loadImage (col + "walk" + facing + "3");
	arr [18] = loadImage (col + "jump" + facing + "1");
	arr [19] = loadImage (col + "jump" + facing + "2"); //dit kon seker beter gedoen geword het.
	arr [20] = loadImage (col + "fall" + facing + "1"); //maar dit mag onnodige bugs veroorsaak het, dit
	arr [21] = loadImage (col + "fall" + facing + "2"); //word min genoeg gerun om hierdie bietjie tikwerk
	arr [22] = loadImage (col + "crouch" + facing); //te veroorsaak
	arr [23] = loadImage (col + "roll" + facing + "1");
	arr [24] = loadImage (col + "roll" + facing + "2");
	arr [25] = loadImage (col + "roll" + facing + "3");
	arr [26] = loadImage (col + "crouchs" + facing);
	arr [27] = loadImage (col + "shoot" + facing);

	arr [28] = loadImage (col + "climb1");
	arr [29] = loadImage (col + "climb2");
	return arr;


    }


    public BufferedImage getPowerupImage (int x)
    {
	return powerupArray [x];
    }



}
