/*
Fisiese class van warriors wat in game rondhardloop.
*/

import java.awt.*;
import java.awt.image.*;

final class Warrior
{
    Powerup powerup = null;
    boolean invisible, shocking;
    int framecount = 0; //vir animasie
    public int moveSpeed = 3;
    public int shooting;
    public int score = 0;
    public int facing = 1; //kyk hy links of regs? neg. = links, pos = regs.
    public int dead = 0; //is hy dood? 0 beteken lewendig. as dit nie = 0, hoe moet hy doodgaan? op vlieg(1), of net verkrummel(2) of val hy onder af (3)?
    public int xPos = 0;
    public int yPos = 0;
    int jumpStrength = 12;
    public int width;
    public int length;
    public int startLength;
    public int startx;
    public int starty;
    public int rolling = 0; //hy rol vir 'n paar frames, dit tel hoe ver hy rol. as dit 0 is, rol hy nie.
    public int endroll = 10; //hoeveel frames hy rol
    boolean crouching = false;
    public int xspd = 0, yspd = 0; //word gebruik as hy val
    int freezeTime = 0;
    BufferedImage[] imagearr;
    //public int status = 0; //Status se wat jy doen, val, spring, loop, watookal.. dit het weggeval.
    public boolean controllable = true; //as hy controllable is, staan hy stil/ is hy op 'n tou en kan hy beweeg
    public boolean onRope = false;      //is hy besig om tou te klim
    public boolean tagged = false;

    String color, name = "";
    Game game;
    boolean[] keys;
    //x en y punt is links van warrior, onder.
    public Warrior (Game owner, int x, int y, String col, boolean[] key)
    {
	game = owner;
	width = game.gridWidthPix / 5 * 4;
	startLength = game.gridLengthPix / 5 * 4;
	startx = x;
	starty = y;
	color = col;
	length = startLength;
	keys = key;


    }


    public void setName (String newName)
    {
	name = newName;
    }


    public String getName ()
    {
	return name;
    }


    public void reset ()
    {

	freezeTime = 0;
	powerup = null;
	invisible = false;
	shocking = false;
	onRope = false;
	shooting = 0;
	dead = 0;
	xspd = 0;
	yspd = 0;
	rolling = 0;
	xPos = startx;
	yPos = starty;
	if (game.tagMode && tagged)
	    moveSpeed = 4;
	else
	    moveSpeed = 3;

    }


    /**
     * Method loadImages
     *
     *
     */
    public void loadImages (ImageUtil iu)
    {
	imagearr = iu.getWarriorImages (color);
    }


    boolean onGr = false;   //ou debug value wat nou gebruik word vir collision detection.


    //update method bepaal hoe die speler beweeg. hoewel dit langdradig lyk, word if/else strukture gebruik wat dit vinnig laat loop
    public void update ()
    {
	// onGr = false; //Debug



	if (dead != 0)
	{
	    if (dead == 1)
	    {
		yspd = 0;
		yPos -= 30;
	    }
	    if (dead == 2)
	    {
		xspd = 0;
		yspd = 0;
		if (length > 0)
		    length -= 2;
	    }
	    if (dead == 3)
		yspd++;
	}
	else
	    if (game.tagMode && freezeTime > 0)
	    {
		freezeTime--;
		return;
	    }
	    else
		if (keys [4] && powerup instanceof Teleport) //enige tyd teleport
		    powerup.use ();
		else
		    if (shooting != 0)
		    {
			onGr = true;
			xspd = 0;
			if (shooting > 0) //forcegun
			{
			    if (shooting == 8)
			    {
				game.playSound (SoundUtil.FORCESHOOT);
				if (facing < 0)
				    game.ar.add (new ForceBullet (xPos - 1, yPos - (length / 9 * 5), true));
				else //facing right
				    game.ar.add (new ForceBullet (xPos + width + 1, yPos - (length / 9 * 5), false));

			    } //shooting ==5
			    shooting++;
			    if (shooting == 16)
				shooting = 0;
			} //if shooting > 0
			else //(if shooting < 0)
			{
			    if (shooting == -10)
			    {
				if (facing < 0)
				{
				    game.ar.add (new Bullet (xPos - 1, yPos - (length / 9 * 5), true, game));
				    game.addExplosion (xPos - 1, yPos - (length / 9 * 5), 8);
				}
				else //facing right
				{
				    game.addExplosion (xPos + 30 + 1, yPos - (length / 9 * 5), 8);
				    game.ar.add (new Bullet (xPos + width + 1, yPos - (length / 9 * 5), false, game));
				}
				game.playSound (SoundUtil.SHOOTGUN);
			    }
			    shooting--;
			    if (shooting == -16)
				shooting = 0;

			}
		    }


	else
	    if (onRope)
	    {
		onGr = false; //Debug
		int xPosGrid = xPos / game.gridWidthPix; //op watter grid is hy?
		int yPosGrid = (yPos + 3) / game.gridLengthPix;
		if (keys [0])
		    if (game.grid [xPosGrid] [yPosGrid] == 1 || game.grid [xPosGrid] [yPosGrid] == 3)
		    {
			yPos -= 3;
			framecount++; //vir animasie
		    }
		if (keys [1])
		{
		    onRope = false;
		    xspd = -3;
		}
		if (keys [2])
		    if (yPosGrid != game.gridHeight - 1)
			if (game.grid [xPosGrid] [yPosGrid + 1] == 1 || game.grid [xPosGrid] [yPosGrid + 1] == 3)
			{
			    yPos += 3;
			    framecount++;
			}
		if (keys [3])
		{
		    onRope = false;
		    xspd = moveSpeed;
		}
	    } //if onrope


	else
	    if (onGround ())
	    {

		onGr = true; //Debug
		if (yspd != 0)
		    if (rolling == 0)
			game.playSound (SoundUtil.FALLSOFT);
		    else
			game.playSound (SoundUtil.FALL);
		yspd = 0;
		if (crouching)
		{
		    rolling = 1;
		    if (keys [4] && powerup instanceof Gun)
			powerup.use ();
		    if (!keys [2]) //as hy as los..
		    {
			crouching = false;
			length = startLength;   //staan weer
			rolling = 0;
		    }
		}
		else
		    if (rolling == 0) //hy rol en crouch nie
		    {
			xspd = 0;

			if (keys [1]) //laat hom links/regs beweeg
			    xspd = -moveSpeed;
			if (keys [3])
			    xspd = moveSpeed;
			if (keys [2])
			{
			    if (xspd == 0 && atRope ()) //sit hom op die tou
			    {
				onRope = true;

			    } // if xspd
			    else
			    {
				if (xspd != 0)
				    rolling = 1; //laat hom begin rol as hy nie stilstaan nie
				else
				{
				    crouching = true;          //anders crouch hy (as hy nie stilstaan nie)
				    length = startLength / 2;
				}
				//crouch

			    }
			} // if keys[2]
			else
			    if (keys [4]) //weapon)
			    {
				if (powerup != null)
				    powerup.use ();
				keys [4] = false;
			    }
			    else
				if (keys [0]) //op
				{
				    if (xspd == 0 && atRope ())
				    {
					onRope = true;

				    } // if xspd
				    else
				    {
					yspd -= jumpStrength;

					game.playSound (SoundUtil.JUMP);
				    }
				} //if keys[0]
		    } //if rolling = 0
		    else //if rolling != 0
		    {
			if (rolling == 1) //laat hom begin rol
			{

			    length = startLength / 2;
			    rolling++;
			}
			else if (rolling == endroll)
			{
			    if (keys [2])
			    {
				crouching = true;
				xspd = 0;
			    }
			    else
			    {
				length = startLength;
				rolling = 0;
			    }

			}
			else
			    rolling++;


		    } //if rolling !=0

	    } // if onground


	else
	{ //as hy in die lug is..
	    onGr = false; //Debug
	    length = startLength; //vir ingeval hy besig was om te rol to hy afval
	    if (rolling > 1) //hy moet weer van voor af begin rol.
		rolling = 1;
	    yspd++;
	    if (xPos + xspd < 0 || xPos + width + xspd >= game.SCREENWIDTH)
	    {
		xspd = -xspd;
		rolling = 1;
	    }
	}


	if (xspd != 0)
	    facing = xspd;
	xPos += xspd;
	yPos += yspd;
    }


    public void die (int deathStyle)
    {
	dead = deathStyle;
	if (dead == 3)
	    game.playSound (SoundUtil.FALLDEATH);
	if (dead == 2)
	    game.playSound (SoundUtil.DIEBULLET);
	game.notifyDeath ();
    }


    public boolean onGround ()  //Kyk of hy op die grond is. as hy oor die grond beweeg in vlgnde siklus, sit hom op grond.
    { //Kyk ook of hy nie onder afval nie.
    if (yspd < 0) //as hy op beweeg, moet hy op op grond kan land nie.
    return false;
	int xGrid1 = (xPos + 5) / game.gridWidthPix;
	int xGrid2 = (xPos + width) / game.gridWidthPix;
	int yGrid = (yPos) / game.gridLengthPix;
	int yGridnxt = (yPos + yspd) / game.gridLengthPix;
	if (yPos + yspd >= game.SCREENHEIGHT)
	{
	    if (game.tagMode)
	    {
		// if (xPos > 300)
		//     xPos -= 5;
		// else
		//     xPos += 5;
		// yPos = 0;
		yspd = -25;
		if (xspd == 0)
		    xspd = 3;
		if (tagged)
		    rolling = 1;
		else
		    rolling = 0;
		game.playSound (SoundUtil.BOING);
	    }
	    else
		die (3);
	    return false;
	}


	if (yGridnxt > yGrid)  // as hy in vlgnde siklus nie op dies grid is as nou nie..
	{
	    if (game.grid [xGrid1] [yGridnxt] > 1)
	    {
		yPos = (yGrid + 1) * game.gridLengthPix;

		return true;
	    }

	    if (game.grid [xGrid2] [yGridnxt] > 1)
	    {
		yPos = (yGrid + 1) * game.gridLengthPix;

		return true;
	    }
	}


	if (yPos != yGrid * game.gridLengthPix)   //as hy in die lug is..
	    return false;

	if (game.grid [xGrid1] [yGrid] > 1)      //as sy linkervoet op 'n blok is..
	    return true;
	if (game.grid [xGrid2] [yGrid] > 1)     //as sy regtervoet op 'n blok is..
	    return true;

	return false;
    }


    public boolean atRope ()
    {
	//Figure uit of hy naby die middel van 'n tou is. as hy is, kyk of die gridplek 'n tou het.
	int mid = xPos + (width / 2);
	int gridMid = mid / game.gridWidthPix;
	int gridMidPix = gridMid * game.gridWidthPix + game.gridWidthPix / 2;
	if (game.grid [gridMid] [yPos / game.gridLengthPix] == 3)
	    if (mid >= gridMidPix - 4 && mid <= gridMidPix + 4)
	    {
		xPos = gridMidPix - (width / 2) + 2; //'lock' op middel v. tou
		return true;

	    }


	return false;
    }


    public void fall (int spd)  //laat hom val na 'n collision, met 'n boolean vir links of regs.

    {

	freezeTime = 0;
	shooting = 0;
	crouching = false;
	yPos--;
	onRope = false;
	yspd = -9;
	xspd = spd;
	rolling = 1;


    }


    public void draw (Graphics g)
    {
	int im = 0;
	if (framecount >= 1000)
	    framecount = 0;
	if (freezeTime == 0)
	    framecount++;
	if (shocking) //biekie special effects..
	{
	    if (Math.random () < 0.3 || keys [4]) //elke nou en dan
	    {
		//g.setColor (Color.white);
		//g.fillOval (xPos + (int) (Math.random () * width), yPos - (int) (Math.random () * length), 5, 5);
		game.ar.add (new Explosion (xPos + (int) (Math.random () * width), yPos - (int) (Math.random () * length), 8, game, 4, true, xspd / 3 * 2, yspd / 3));
	    }

	}
	if (game.tagMode && game.tagTime % 4000 < 30 && invisible)
	    game.ar.add (new Explosion (xPos + (int) (Math.random () * width), yPos - (int) (Math.random () * length), 8, game, 4, true, xspd / 3 * 2, yspd / 3));


	if (facing > 0)
	    im += 14;
	if (onRope)
	{
	    if (freezeTime == 0)
		framecount--;  //hy verander framecout daarbo erens klaar as hy tou klim
	    im = 28 + ((framecount / 4) % 2);
	}


	else
	    if (onGr)
	    {
		if (xspd != 0)
		{
		    if (rolling < 2)
		    {
			im += (framecount /2 % 3) + 1;

		    }
		    else //rolling
		    {
			im += 9 + rolling / 4;
		    }
		}
		else //xspd = 0
		{
		    if (crouching || rolling > 1)
		    {
			im += 8;
			if (shooting != 0)
			    im += 4;
		    }
		    else
			if (shooting != 0)
			    im += 13;


		}
	    }
	    else // !onGr
	    {
		if (rolling == 0)
		{
		    if (yspd < 0)
			im += 4;
		    else
			im += 5;
		}
		else
		{
		    im += 6 + framecount / 2 % 2;

		}
	    }




	if (dead == 2)
	    g.drawImage (imagearr [im], xPos, yPos - length, 30, length, null);
	else if (!invisible)
	{
	    g.drawImage (imagearr [im], xPos, yPos - length, null);
	    if (game.tagMode && tagged)
	    {
		g.setColor (Color.white);
		g.drawString ("" + (game.tagTime / 1000 + 1), xPos + width / 2, yPos - length);
	    }
	}


	// if (!invisible)
	// {
	//     g.setColor (color);
	//     g.fillRect (xPos, yPos - length, width, length);
	//     g.setColor (Color.blue);
	//     if (facing < 0)
	//         g.fillOval (xPos, yPos - length + 5, 5, 5);
	//     if (facing > 0)
	//         g.fillOval (xPos + width - 5, yPos - length + 5, 5, 5);
	//
	//     if (shocking)
	//     {
	//         g.setColor (Color.white);
	//         g.drawRect (xPos, yPos - length, width, length);
	//     }
	//
	// }
    }


    public void getPowerup (int type)
    {
	invisible = false; //hy moet weer gesien word. Al kry hy net 'n nuwe invisibility.
	shocking = false;
	game.playSound (SoundUtil.PICKUPPOWERUP);
	switch (type)
	{
	    case 1: //boots
		{
		    powerup = new Boots (this);
		    break;
		}
	    case 2: //Force gun
		{
		    powerup = new ForceGun (this);
		    break;
		}
	    case 3: //invisibility
		{
		    powerup = new Invisibility (this);
		    break;
		}

	    case 4: //teleport
		{
		    powerup = new Teleport (this);
		    break;
		}
	    case 5: //Gun
		{
		    powerup = new Gun (this);
		    break;
		}

	    case 6: //mine
		{
		    powerup = new MinePowerup (this);
		    break;
		}

	    case 7: //shocker
		{
		    game.playSound (SoundUtil.CHARGEUP);
		    shocking = true;
		    powerup = null;
		    break;
		}
	}
    }


    public void plantMine ()
    {
	xspd = 0;
	rolling = 1;
	powerup = null;
	if (facing > 0) //kyk regs.
	    game.addMine (xPos + width + 1, yPos);
	if (facing < 0) //kyk links.
	    game.addMine (xPos - 6, yPos);

    }


    public void shoot (boolean forcegun)
    {
	if (forcegun)
	    shooting = 1;
	else
	    shooting = -1;
    }
}


